close all
clear all
clc

t = (1:20)';
t1 = t(2:end);
t2 = t(3:end);
t3 = t(4:end);
t4 = t(5:end);

n = length(t);
e = randn(n,1);

b0 = 3;
b1 = 2;
b2 = 0.5;
b3 = 1.2;

p0 = (b0*ones(size(t))) + e/4;
p1 = b0 + b1*t + e;
p2 = b0 + b1*t + b2*t.^2 + e*6;
p3 = b0 + b1*t + b2*t.^2 + b3*t.^3 + e*100;

d1_p0 = diff(p0);
%
d1_p1 = diff(p1);
d2_p1 = diff(d1_p1);
%
d1_p2 = diff(p2);
d2_p2 = diff(d1_p2);
d3_p2 = diff(d2_p2);
%
d1_p3 = diff(p3);
d2_p3 = diff(d1_p3);
d3_p3 = diff(d2_p3);
d4_p3 = diff(d3_p3);


%--------------------------------------------
% POLYNOM STUPNE 0
%--------------------------------------------
figure
subplot(2,1,1)
plot(t,p0)
title('polynom stupne 0')
grid
subplot(2,1,2)
plot(t1,d1_p0)
title('prvni diference')
grid

%--------------------------------------------
% POLYNOM STUPNE 1
%--------------------------------------------
figure
subplot(3,1,1)
plot(t,p1)
title('polynom stupne 1')
subplot(3,1,2)
plot(t1,d1_p1)
title('prvni diference (konst.)')
grid
subplot(3,1,3)
plot(t2,d2_p1)
title('druhe diference (nula)')
grid

%--------------------------------------------
% POLYNOM STUPNE 2
%--------------------------------------------
figure
subplot(2,2,1)
plot(t,p2)
title('polynom stupne 2')
subplot(2,2,2)
plot(t1,d1_p2)
title('prvni diference')
subplot(2,2,3)
plot(t2,d2_p2)
title('druhe diference (konst.)')
grid
subplot(2,2,4)
plot(t3,d3_p2)
title('treti diference (nula)')
grid

%--------------------------------------------
% POLYNOM STUPNE 3
%--------------------------------------------
figure
subplot(3,2,1)
plot(t,p3)
title('polynom stupne 3')
subplot(3,2,2)
plot(t1,d1_p3)
title('prvni diference')
subplot(3,2,3)
plot(t2,d2_p3)
title('druhe diference')
subplot(3,2,4)
plot(t3,d3_p3)
title('treti diference (konst.)')
grid
subplot(3,2,5)
plot(t4,d4_p3)
title('ctvrte diference (nula)')
grid












